#-*-ruby-*-
#
# Copyright (c) 2004 SASADA Koichi <ko1 at atdot.net>
#
# This program is free software with ABSOLUTELY NO WARRANTY.
# You can re-distribute and/or modify this program under
# the same terms of the Ruby's lisence.
#
#
# Sixamo bot
#
# add config like this:
#
# BotConfig = {
#   :SixamoBot => {
#     :dir => 'dokoka',
#     :ch  => /nadoka/,
#     :tm  => 5
#     :id  => /(sixamo)|()/
#   }
# }
#
#
# $Id: sixamo.nb,v 1.7 2004/04/30 21:36:25 ko1 Exp $
#

require 'sixamo'
require 'kconv'
class SixamoBot < Nadoka::NDK_Bot
  def bot_initialize
    @sixamo_dir = @bot_config[:dir] || '~/sixamo'
    @sixamo_ch  = @bot_config[:ch]  || '#nadoka'
    @sixamo_tm  = @bot_config[:tm]  || 5
    @sixamo_id  = @bot_config[:id]  || /(sixamo)|()/
    @prev = Time.now
    make_sixamo
  end

  def make_sixamo
    @sixamo = Sixamo.new(File.expand_path(@sixamo_dir))
  end
  
  def on_privmsg prefix, ch, msg
    return unless @sixamo_ch === ch
    
    begin
      msg = Kconv.toeuc(msg)
      @sixamo.memorize msg

      unless @sixamo_id === msg
        return if Kernel.rand(2) == 1
        return if Time.now - @prev < @sixamo_tm
      end
      @prev = Time.now

      talk = Kconv.tojis(@sixamo.talk(msg))
      send_notice ch, 'sixamo: ' + talk
    rescue
      make_sixamo
    end

  end
end

